#ifndef PTHREAD_SIMULATION_HPP
#define PTHREAD_SIMULATION_HPP

#include <vector>
#include <pthread.h>
#include <BarnesHutTree.hpp>
#include "Simulation.hpp"

namespace nbody {
	class PthreadSimulation : public Simulation {
		friend class BarnesHutTreeThreaded;
	protected:
		vector<pthread_t> threads;
	public:
		PthreadSimulation();
		virtual ~PthreadSimulation();
		virtual void initialize(string inputFile);
		virtual void cleanup();
		virtual int getNumberOfProcesses();
		virtual int getProcessId();
		virtual void runStep();
	};
}

#endif
